//******************************************************************************
// Software License Agreement
//
// The software supplied herewith by Microchip Technology
// Incorporated (the "Company") is intended and supplied to you, the
// Companys customer, for use solely and exclusively on Microchip
// products. The software is owned by the Company and/or its supplier,
// and is protected under applicable copyright laws. All rights are
// reserved. Any use in violation of the foregoing restrictions may
// subject the user to criminal sanctions under applicable laws, as
// well as to civil liability for the breach of the terms and
// conditions of this license.
//
// THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION. NO WARRANTIES,
// WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
// TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
// PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT,
// IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
// CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
//
//******************************************************************************

// *****************************************************************************
// Filename:  Cap_Sense.h
// Date: Dec. 13, 2007
// Purpose: Defines and Vars for Cap_Sense.c module demo
// *****************************************************************************


#ifndef MAIN727_H
#define MAIN727_H
// Execute contained code ONE-TIME ONLY

// Create FFlag variable type
// Used for application status bit flags
typedef struct {
	char SSPBF : 1;
} FFlags;

// Create BButton variable type 
// Used for bit indicators for button presses
typedef struct {
	char BTN0 :1;						// {byte 0}
	char BTN1 :1;
	char BTN2 :1;
	char BTN3 :1;
	char BTN4 :1;
	char BTN5 :1;
	char BTN6 :1;
	char BTN7 :1;
	char BTN8 :1;						// {byte 1}
	char BTN9 :1;
	char BTN10:1;
	char BTN11:1;
	char BTN12:1;
	char BTN13:1;
	char BTN14:1;
	char BTN15:1;						// Create bitfield for sensors 0-15
} BButtons;

#endif /* MAIN727_H */



// Defines
// Pinouts

#define LED0			RA0
#define LED1			RE2
#define LED2			RE0
#define LED3			RA1

#define ON				0		// active low leds
#define OFF				1		//

#define NUM_BTTNS		16



/** Variables **/
extern bank1 unsigned int	reading[NUM_BTTNS];
extern bank1 unsigned int	average[NUM_BTTNS];
extern bank1 unsigned int	threshold;
//extern bank1 long			percent;
extern unsigned char		index;

extern bank2 unsigned int 	threshold128;			// Threshold of 1/128th = 1/128th of the average value
extern bank2 unsigned int 	threshold64;			// ... used in computation of threshold variable
extern bank2 unsigned int 	threshold32;			// ... threshold is a selection of the sum of these
extern bank2 unsigned int 	threshold16;			//         "
extern bank2 unsigned int 	threshold8;				//         "
extern bank2 unsigned int	threshold4;				//         "
extern bank2 unsigned int 	threshold2;				// Threshold value for 1/2

extern FFlags Flags;
extern BButtons Buttons;
